<template>
    <div>

        <el-form :model="formData" :rules="formRules" ref="dataForm">
            <el-button-group style="display: flex;margin: -50px 0 10px 80%; height: 35px">
                <el-button
                    type="primary"
                    @click.native="saveOrder()"
                >草稿保存
                </el-button
                >
                <el-button
                    v-if="visiblV === 0"
                    type="primary"
                    @click.native="submit('0')"
                >提交
                </el-button
                >

            </el-button-group>
            <el-card>
                <el-row :gutter="20">
                    <el-col :span="2">
                        <div class="ao-text">
                            <span>入库单号：</span>
                        </div>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item prop="corpOrderId">
                            <el-input v-model="formData.corpOrderId" auto-complete="off"
                                      :disabled="corpOrderIdDisabled"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="2">
                        <div class="ao-text">
                            <span>单据时间：</span>
                        </div>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item prop="actDate">
                            <el-date-picker
                                v-model="formData.actDate"
                                type="datetime"
                                placeholder="单据时间"
                                :disabled="true"
                                style="width: 100%; "
                            >
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :span="2">
                        <div class="ao-text">
                            <span>往来单位：</span>
                        </div>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item prop="fromCorp">
                            <el-input v-model="formData.fromCorp" auto-complete="off" :disabled="true"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="2">
                        <div class="ao-text">
                            <span>单据类型：</span>
                        </div>
                    </el-col>
                    <el-col :span="8">
                        <el-form-item class="query-form-item">
                            <el-select v-model="formData.billType" placeholder="请选择单据类型" @change="actionChange"
                                       :disabled="corpOrderIdDisabled"
                                       clearable>
                                <el-option

                                    v-for="item in busTypes"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.action">
                                    <span style="float: left">{{ item.name }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">

                    <el-col :span="2">
                        <div class="ao-text">
                            <span>当前仓库：</span>
                        </div>
                    </el-col>

                    <el-col :span="8">
                        <el-form-item prop="locStorageCode">
                            <el-select v-model="formData.locStorageCode" placeholder="当前仓库信息" clearable
                                       :disabled="corpOrderIdDisabled">
                                <el-option
                                    v-for="item in storageList"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.code">
                                    <span style="float: left">{{ item.name }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
            </el-card>
            <el-card>
                <el-row :gutter="20">
                    <el-col :span="2">
                        <div class="ao-text">
                            <span>条码：</span>
                        </div>
                    </el-col>
                    <el-col :span="19">
                        <el-form-item prop="code">
                            <el-input
                                @keypress.enter.native="enterKey($event)"
                                v-model="formData.code"
                                ref='inputRef'
                                @focus="getInputFocus($event)"
                            ></el-input>
                        </el-form-item>

                    </el-col>
                    <el-col :span="2">
                        <el-button
                            type="primary"
                            size="small"
                            @click.native.stop="addCode()"
                            style="height: 31px; margin-left: 2px"
                        >确定
                        </el-button
                        >
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :span="16" style="margin-left: 40px">
                        <el-checkbox v-model="sitcomScan">分段扫码</el-checkbox>
                    </el-col>
                    <el-col :span="4">
                        <div class="text item" style="margin-left: 30px"> 条码数量：{{ total }}
                        </div>
                    </el-col>


                </el-row>
                <el-table v-loading="loading" :data="codeArray" style="width: 100%;" max-height="350" height="350"
                          :row-style="rowStyle"
                          ref="multipleTable">
                    <el-table-column label="序号" type="index" width="45"></el-table-column>
                    <el-table-column
                        label="条码"
                        prop="code"
                        show-overflow-tooltip
                    ></el-table-column>
                    <el-table-column
                        label="扫码数量"
                        prop="count"
                        width="80"
                        show-overflow-tooltip
                    ></el-table-column>

                    <el-table-column label="操作" fixed="right" width="250">
                        <template slot-scope="scope">
                            <el-button
                                type="text"
                                size="small"
                                @click.native.stop="deleteCode(scope.$index, scope.row)"
                            >减一
                            </el-button
                            >
                            <el-button
                                type="text"
                                size="small"
                                @click.native.stop="bindRl(scope.row)"
                            >选择产品
                            </el-button
                            >
                            <!--                               :disabled="scope.row.relId != null "-->
                            <!--                            <el-button-->
                            <!--                                type="text"-->
                            <!--                                size="small"-->
                            <!--                                :disabled=" scope.row.supId !=null"-->
                            <!--                                @click.native.stop="handleUnitClick(scope.row)"-->
                            <!--                            >选择供应商-->
                            <!--                            </el-button-->
                            <!--                            >-->
                        </template>
                    </el-table-column>
                </el-table>

                <div class="block">
                    <el-pagination
                        @current-change="handleCurrentChange"
                        layout="prev, pager, next,total"
                        :current-page="query.page"
                        :page-size="query.limit"
                        :total="total">
                    </el-pagination>
                </div>
            </el-card>
        </el-form>
        <el-dialog
            title="选择供应商"
            :visible.sync="dialogTableVisible"
            v-if="dialogTableVisible"
            width="70%"
            append-to-body
        >
            <DialogSelectUnit
                :codeId="curRow"
                v-on:selectSupUnit="selectSupUnit"
                v-on:closeBindDialog="closeBindDialog"
            ></DialogSelectUnit>
        </el-dialog>
        <el-dialog
            title="绑定产品ID"
            :visible.sync="selectRlVisible"
            width="80%"
            v-if="selectRlVisible"
            append-to-body
        >
            <selectRlDialog
                :curRow="curRow"
                :curAction="curAction"
                v-on:selectBindRl="selectBindRl"
                v-on:closeBindDialog="closeBindDialog"
            ></selectRlDialog>
        </el-dialog>
    </div>
</template>

<script>
import {
    orderGetUdi,
    orderList,
    codeList,
    orderListError,
    saveOrderWeb,
    mergeOrder,
    postOrdersWeb,
    errorCodeList,
    addOrderWeb,
    deleteCodesTempById,
    submitOrderWeb,
    updateCodeBindSup
} from "../../api/warehouse/order";
import draggable from "vuedraggable";
import {parseTime} from "../../filtres/index";
import store from "../../store";
import {filterAllByUser} from "@/api/basic/invWarehouse";
import {getBusTypeByUser} from "../../api/warehouse/BusRole";
import DialogSelectUnit from "./DialogSelectUnit";
import selectRlDialog from "./DialogSelectRl";

const formJson = {
    corpOrderId: "",
    code: "",
    actor: "",
    fromCorpId: "",
    fromCorp: "医院",
    fromType: null,
    locStorageCode: null,
    actDate: new Date(),
    billType: null,
};

export default {
    name: "idQuery",
    props: {
        closeDialog: {
            type: Function,
            required: true,
        },
        idQuery: {
            type: Object,
            required: true,
        },
        addType: {
            type: Object,
            required: true,
        },
    },
    data() {
        return {
            codeQuery: {
                code: "",
            },
            query: {
                code: "",
                corpOrderId: "",
                page: 1,
                limit: 10,
            },
            formData: formJson,
            formRules: {
                temp: [
                    {required: true, message: "请输入条码", trigger: "blur"}
                ],
            },
            visiblV: 0,
            corpOrderIdDisabled: false,
            codeArray: [],
            total: 0,
            loading: false,
            index: null,
            formLoading: false,
            formVisible: false,
            deleteLoading: false,
            orderNo: null,
            curRow: null,
            busTypes: [],
            storageList: [],
            selectRlVisible: false,
            dialogTableVisible: false,
            sitcomScan: false,
        };
    },
    components: {
        draggable, DialogSelectUnit, selectRlDialog
    },
    methods: {
        submit(formName) {
            if (this.total < 1) {
                this.$message.error('未添加条码');
                return;
            }

            let tQuery = {
                orderId: this.idQuery.id,
                action: this.formData.billType,
                locStorageCode: this.formData.locStorageCode,
            }

            submitOrderWeb(tQuery)
                .then((response) => {
                    if (response.code === 20000) {
                        this.$message.success("提交成功");
                        this.closeDialog();
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                });

        },

        saveOrder() {
            if (this.formData.billType == null || this.formData.billType == '') {
                this.$message.error('未选择扫码单据类型');
                return
            }
            if (this.formData.locStorageCode == null || this.formData.locStorageCode == '') {
                this.$message.error('当前仓库不能为空');
                return;
            }
            let tQuery = Object.assign(JSON.parse(JSON.stringify(this.formData)));
            tQuery.orderId = this.idQuery.id;
            tQuery.actDate = parseTime(this.formData.actDate, '{y}-{m}-{d} {h}:{i}:{s}');
            tQuery.action = tQuery.billType;
            saveOrderWeb(tQuery).then((response) => {
                if (response.code === 20000) {
                    this.closeDialog();
                } else {
                    this.$message.error(response.message);
                }
                this.loading = false;
            });
        },
        // 刷新表单
        resetForm() {
            if (this.$refs["dataForm"]) {
                // 清空验证信息表单
                this.$refs["dataForm"].clearValidate();
                // 刷新表单
                this.$refs["dataForm"].resetFields();
                this.getList();
            }
        },

        enterKey(event) {
            if (this.sitcomScan) {
                return;
            } else {
                this.addCode(event);
            }
        },
        addCode(event) {
            if (event == null) {
                this.$refs.inputRef.focus();
            } else event.target.select();
            if (this.$isBlank(this.formData.billType)) {
                this.$message.warning("请选择单据类型！");
                return;
            }
            if (this.$isBlank(this.formData.locStorageCode)) {
                this.$message.error('当前仓库不能为空');
                return;
            }
            this.formData.corpOrderId = this.formData.corpOrderId.trim();
            if (this.$isBlank(this.formData.corpOrderId)) {
                let date = new Date();
                this.formData.corpOrderId = parseTime(date, '{y}{m}{d}{h}{i}{s}') + Math.ceil(Math.random() * 89 + 10);
            }
            this.formData.code = this.formData.code.trim();
            if (this.$isBlank(this.formData.code)) return;
            this.loading = true;

            let tQuery = Object.assign(JSON.parse(JSON.stringify(this.formData)));
            tQuery.orderId = this.idQuery.id;
            tQuery.actDate = parseTime(this.formData.actDate, '{y}-{m}-{d} {h}:{i}:{s}');
            tQuery.action = tQuery.billType
            this.addCodeSubmit(tQuery);
        },

        addCodeSubmit(tQuery) {
            addOrderWeb(tQuery).then((response) => {

                // let teQuery = {code: this.formData.code};
                // expireTimeCheck(teQuery).then((response) => {
                //     if (response.code === 20000) {
                //     } else {
                //         this.$message.warning(response.message);
                //     }
                //     this.loading = false;
                // });


                if (response.code === 20000) {
                    this.idQuery.id = response.data.orderId;
                    if (response.data.errMsg != null) {
                        this.$alert(response.data.errMsg, '提示', {
                            confirmButtonText: '确定',
                            type: 'warning',
                            closeOnClickModal: true,
                            callback: action => {
                            }
                        });
                    }
                    this.corpOrderIdDisabled = true;
                    this.$refs.inputRef.focus();
                    this.getCodeList();
                } else {
                    this.corpOrderIdDisabled = true;
                    if (response.code == 502) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectRlTitle = response.message;
                        this.bindRl(response.data);
                        // this.$alert(response.message, '提示', {
                        //     confirmButtonText: '确定',
                        //     type: 'warning',
                        //     closeOnClickModal: true,
                        //     callback: action => {
                        //         this.bindRl(response.data);
                        //     }
                        // });
                    } else if (response.code == 503) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectUnitTitle = response.message;
                        this.handleUnitClick(response.data);
                        // this.$alert(response.message, '提示', {
                        //     confirmButtonText: '确定',
                        //     type: 'warning',
                        //     closeOnClickModal: true,
                        //     callback: action => {
                        //         this.handleUnitClick(response.data);
                        //     }
                        // });
                    } else if (response.code == 504) {

                        this.$confirm(response.message, "提示", {
                            confirmButtonText: "确定",
                            cancelButtonText: "忽略",
                            type: "error",
                        }).then(() => {
                            tQuery.ignoreExpire = true;
                            this.addCodeSubmit(tQuery)
                        }).catch(() => {

                        });

                    } else if (response.code == 505) {

                        this.$confirm(response.message, "提示", {
                            confirmButtonText: "确定",
                            cancelButtonText: "忽略",
                            type: "warning",
                        }).then(() => {
                            tQuery.ignoreRecentExpire = true;
                            this.addCodeSubmit(tQuery)
                        }).catch(() => {

                        });

                    } else {
                        this.$alert(response.message, '提示', {
                            confirmButtonText: '确定',
                            type: 'warning',
                            closeOnClickModal: true,
                            callback: action => {
                                this.$refs.inputRef.focus();
                            }
                        });
                    }
                }
                this.loading = false;
            });
        },


        deleteCode(index, row) {
            this.$confirm("是否确定移除一个条码?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            }).then(() => {
                this.loading = true;
                let tQuery = {
                    id: row.id
                }
                deleteCodesTempById(tQuery)
                    .then((response) => {
                        if (response.code === 20000) {
                            this.getCodeList();
                        } else {
                            this.$message.error(response.message);
                        }
                        this.loading = false;
                    });
            }).catch(() => {
            });
        },
        getInputFocus(event) {
            event.currentTarget.select();
        },
        tableSelection() {
            this.$refs.multipleTable.clearSelection();
            this.$refs.multipleTable.toggleAllSelection();
        },
        handleSizeChange(val) {
            this.query.limit = val;
            this.getCodeList();
        },
        handleCurrentChange(val) {
            this.query.page = val;
            this.getCodeList();
        },
        getCodeList() {
            this.loading = true;
            this.query.orderId = this.idQuery.id;
            errorCodeList(this.query) //查找该单号下的所有条码
                .then((response) => {
                    this.codeArray = response.data.list || [];
                    this.total = response.data.total || 0;
                    for (let i = 0; i < this.codeArray.length; i++) {
                        this.codeArray[i].fromType = this.formData.fromType;
                        this.codeArray[i].billType = this.formData.billType;
                    }
                    this.tableSelection();
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        getBusType() {
            let query = {
                enabled: true,
            };
            getBusTypeByUser(query)
                .then((response) => {
                    this.busTypes = response.data.list || [];
                    this.curAction = this.busTypes[0];
                    this.getStorage(this.formData.billType);
                })
                .catch(() => {
                });
        },
        intentBack() {
            this.$router.go(-1);
        },
        getStorage(event) {
            let query = {};
            this.storageList = [];
            filterAllByUser(query)
                .then((response) => {
                    this.storageList = response.data || [];
                })
                .catch(() => {
                });
        },
        getActionName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i].advanceType;
                }
            }
        },
        getActionItem(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i];
                }
            }
        },
        actionChange(item) {
            this.curAction = this.getActionItem(item);
            // this.formData.locStorageCode = this.curAction.storageCode;
        },
        //绑定数据
        bindRl(val) {
            this.curRow = val;
            this.selectRlVisible = true;
        },


        selectBindRl(row) {
            let query = {
                id: this.curRow.id,
                relId: row.id,
            };
            updateCodeBindSup(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success("绑定成功");
                    this.idQuery.id = this.curRow.orderId;
                    this.getCodeList();
                } else {

                    if (response.code == 503) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectUnitTitle = response.message;
                        this.handleUnitClick(response.data);
                    } else
                        this.$message.error(response.message);
                }
            }).catch(() => {

            });
        },
        closeBindDialog(val) {
            this.selectRlVisible = false;
            this.dialogTableVisible = false;
        },
        rowStyle({row, rowIndex}) {
            let rowBackground = {};
            if (row.supId == null || row.relId == null) {
                //rowBackground.background="#f6f5ee";
                rowBackground.color = '#f60303';
            }

            return rowBackground;
        },

    },
    filters: {},
    mounted() {
        document.body.ondrop = function (event) {
            event.preventDefault();
            event.stopPropagation();
        };
    },
    created() {
        this.formData.code = '';
        this.formData.actDate = new Date();
        this.codeArray = [];
        this.formData.fromCorp = store.getters.companyName;// store.getters.customerId === 110 ? '医院' : store.getters.companyName;
        this.formData.fromCorpId = store.getters.customerId;
        this.formData.customerId = store.getters.customerId;
        this.getBusType();
        this.getStorage();
        if (this.$isNotBlank(this.idQuery.id)) {
            this.formData.actDate = new Date(this.idQuery.actDate);
            this.formData.corpOrderId = this.idQuery.corpOrderId;
            this.formData.billType = this.idQuery.billType;
            this.formData.locStorageCode = this.idQuery.locStorageCode;
            this.corpOrderIdDisabled = true;

            if (this.addType == "edit") {
                this.visiblV = 1;
            }
            this.getCodeList();
        } else {
            this.corpOrderIdDisabled = false;
            if (JSON.stringify(this.$route.query) === '{}') {
                // this.formData.corpOrderId = new Date().getTime() + (Math.ceil(Math.random() * 10 + 10) + '');
                let date = new Date();
                this.formData.corpOrderId = parseTime(date, '{y}{m}{d}{h}{i}{s}') + Math.ceil(Math.random() * 89 + 10);
            } else {
                // 将参数拷贝进查询对象
                let query = this.$route.query;
                this.orderNo = query.id;

                this.query = Object.assign(this.query, query);
                this.query.limit = parseInt(this.query.limit);
                this.query.corpOrderId = query.id;

                // 加载表格数据
                // this.getCodeList();
            }
        }
    },
};
</script>
<style>

.ao-text {
    width: 100%;
    font-size: 13px;
    font-family: "Microsoft YaHei";
    float: right;
    text-align: right;
    margin-top: 10px;
}

</style>



